--------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:05:11 04/29/2011 
-- Design Name: 
-- Module Name:    TOP_TEST_SERIE - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
library UNISIM;
use UNISIM.VComponents.all;


entity TOP_TEST_SERIE is
port
(
--SIMPLlugIN-LX45 base board RESOURCES
	CLK_25											: in 		std_logic;
	RESET_POW_ON									: in 		std_logic;
	PUSH_BUTTOM_1_N								: in 		std_logic;
	SWITCH_1_N										: in 		std_logic;
	LED1_N											: out 	std_logic;
	LED2_N                                 : out 	std_logic;
	LED3_N                                 : out 	std_logic;
	LED4_N                                 : out 	std_logic;
	
-- SIMPlugIN-SERIAL resources	
   -- RS232 port
	DTR0_N	                              : out 	std_logic;		--	CON7_17
	TXD0                                   : out 	std_logic;		-- CON7_18
	RTS0_N                                 : out 	std_logic;		-- CON7_19
	RXD0                                   : in	 	std_logic;		-- CON7_20
	CTS0_N                                 : in  	std_logic;		-- CON7_23
	RI0_N                                  : in  	std_logic;		-- CON7_24
	DCD0_N                                 : in  	std_logic;		-- CON7_25
	DSR0_N                                 : in  	std_logic;		-- CON7_26
   -- RS485 ports
	RXD2												: in	 	std_logic;		--	CON7_05
	RXD1_ENA_N                             : out 	std_logic;		-- CON7_06
	RXD1                                   : in	 	std_logic;		-- CON7_07
	TXD1_ENA                               : out 	std_logic;		-- CON7_08
	TXD1                                   : out 	std_logic;		-- CON7_11
	RXD2_ENA_N                             : out 	std_logic;		-- CON7_12
	TXD2_ENA                               : out 	std_logic;		-- CON7_13
	TXD2                                   : out 	std_logic		-- CON7_14
);
end TOP_TEST_SERIE;

architecture Behavioral of TOP_TEST_SERIE is

signal	CLK					              	:  std_logic;
signal	RST					              	:  std_logic;
signal	DIV_CNT									:	std_logic_vector(7 downto 0);
signal	DIV_CLK				              	:  std_logic;
signal	DBC_CNT									:	std_logic_vector(15 downto 0);
signal	DBC_CLK				              	:  std_logic;
signal	TX_REG									:	std_logic_vector(31 downto 0);
signal	RX_REG									:	std_logic_vector(31 downto 0);
signal	BIT_CNT									:	std_logic_vector(5 downto 0);
signal	I_RXD1_ENA_N							:	std_logic;
signal   I_TXD1_ENA								:	std_logic;
signal   I_TXD1									:	std_logic;
signal   I_RXD2_ENA_N							:	std_logic;
signal   I_TXD2_ENA								:	std_logic;
signal   I_TXD2									:	std_logic;
signal	I_RXD1									:	std_logic;
signal   I_RXD2	                        :	std_logic;
signal	I_DTR0_N									:	std_logic;
signal   I_TXD0									:	std_logic;
signal   I_RTS0_N									:	std_logic;
signal	I_RXD0									:	std_logic;
signal   I_CTS0_N 								:	std_logic;
signal   I_RI0_N  								:	std_logic;
signal   I_DCD0_N                         :  std_logic;
signal   I_DSR0_N									:  std_logic;
signal	PUSH_F									:	std_logic_vector(4 downto 0);
signal	PUSH_CNT									:	std_logic_vector(1 downto 0);
signal	I_ERR_COD								:	std_logic_vector(7 downto 0);
signal   PUSH_BEG									:  std_logic;
signal   START_I									:  std_logic;
signal   BLINK										:  std_logic;


constant	DIV_MAX 	:integer range 1 to 255 := 100;			
constant	DBC_MAX 	:integer range 0 to 65_535 := 8_000;		


constant	TX_PAT	:	std_logic_vector(31 downto 0):=X"0F_10_EF_AA";

--FSM STATIC TEST
type		ST_STATETYPE IS (ST_IDLE,ST_TEST1,ST_TEST2,ST_TEST3,ST_TEST4,ST_TEST5,ST_TEST6,ST_END1,
								  ST_INIT_D1,ST_TXRX_D1,ST_TEST_D1,ST_END2,
								  ST_INIT_D2,ST_TXRX_D2,ST_TEST_D2,ST_END3,
								  ST_INIT_D3,ST_TXRX_D3,ST_TEST_D3,ST_END4,
								  ST_ERROR);
signal	ST_STATE : ST_STATETYPE := ST_IDLE;





begin

CLKIN25_IBUFG_INST : IBUFG
   port map (I=>CLK_25,
             O=> CLK); -- use a global buffer to distribute clock


RST						<= RESET_POW_ON;

--RS485
--OUTPUTS
RXD1_ENA_N           <= I_RXD1_ENA_N; 	         
TXD1_ENA           	<=	I_TXD1_ENA;   
TXD1           		<=	I_TXD1;       
RXD2_ENA_N           <=	I_RXD2_ENA_N; 
TXD2_ENA           	<=	I_TXD2_ENA;   
TXD2           		<=	I_TXD2;       
--INPUTS
I_RXD1					<=	RXD1;
I_RXD2					<= RXD2;

--RS232
--OUTPUTS
DTR0_N 					<= I_DTR0_N;
TXD0 						<= I_TXD0; 	
RTS0_N 					<= I_RTS0_N;

--INPUTS
I_RXD0					<= RXD0;
I_CTS0_N            	<= CTS0_N;
I_RI0_N             	<= RI0_N ;
I_DCD0_N            	<= DCD0_N;
I_DSR0_N            	<= DSR0_N;


--COUNTER to divide CLK (25Mhz)  to get  DIV_CLK ( = 25 MHz / DIV_MAX )
process(RST,CLK)
begin
	if RST = '1' then
		DIV_CNT <= (others=>'0');
		DIV_CLK <= '0';
	elsif rising_edge(CLK)then
		if DIV_CNT = DIV_MAX then
			DIV_CNT <= (others=>'0') after 2 ns;
			DIV_CLK <= '1' after 2 ns;
		else
			DIV_CNT <= DIV_CNT + 1  after 2 ns;
			DIV_CLK <= '0' after 2 ns;
		end if;
	end if;
end process;

--BLINK AND DEBOUNCER COUNTER
--COUNTER to divide CLK (25Mhz)  to get  DBC_CLK ( = 25 MHz / DBC_MAX )
process(RST,CLK)
begin
	if RST = '1' then
		DBC_CNT <= (others=>'0');
		DBC_CLK <= '0';
	elsif rising_edge(CLK)then
		if DIV_CLK = '1' then
			if DBC_CNT = DBC_MAX then
				DBC_CNT <= (others=>'0') after 2 ns;
				DBC_CLK <= '1' after 2 ns;
			else
				DBC_CNT <= DBC_CNT + 1  after 2 ns;
				DBC_CLK <= '0' after 2 ns;
			end if;
		end if;
	end if;
end process;

--SAMPLER PUSH_BUTTOM
process(RST,CLK)
begin
	if RST = '1' then
		PUSH_F <= (others=>'0');
	elsif rising_edge(CLK)then
		if PUSH_BUTTOM_1_N = '1' then
			PUSH_F <= (others=>'0')after 2 ns;
		else
			if DBC_CLK = '1' and DIV_CLK = '1' then
				PUSH_F <= PUSH_F(3 downto 0)& not PUSH_BUTTOM_1_N after 2 ns;
			end if;
		end if;
	end if;
end process;


PUSH_BEG					<='1' when PUSH_F(4)='0' and PUSH_F(3)='0' and PUSH_F(2)='0' and PUSH_F(1)='1' else '0';


--START DFF
process(RST,CLK)
begin
	if RST = '1' then
		START_I <= '0';
	elsif rising_edge(CLK)then
		if DBC_CLK = '1' and DIV_CLK = '1' then
			if PUSH_BEG = '1' then
				START_I <= not START_I after 2 ns;
			end if;
		end if;
	end if;
end process;

--BLINK DFF
process(RST,CLK)
begin
	if RST = '1' then
		BLINK <= '0';
	elsif rising_edge(CLK)then
		if DBC_CLK = '1' and DIV_CLK = '1' then
			BLINK <= not BLINK after 2 ns;
		end if;
	end if;
end process;

--FSM STATIC TEST
--type		ST_STATETYPE IS (ST_IDLE,ST_TEST1,ST_TEST2,ST_TEST3,ST_TEST4,ST_TEST5,ST_TEST6,
--								     ST_ERROR,ST_END);
ST_FSM:	process(CLK, RST)
begin 
	if RST = '1' then
		I_RXD1_ENA_N		<='1'; 
	   I_TXD1_ENA 			<='0';  
      I_TXD1				<='0';       
      I_RXD2_ENA_N 		<='1';
      I_TXD2_ENA			<='0';   
      I_TXD2				<='0';       
		I_DTR0_N				<='1';
      I_TXD0				<='0'; 	
      I_RTS0_N				<='1';
		TX_REG				<=(others=>'0');
      BIT_CNT				<=(others=>'0');
		I_ERR_COD 			<= X"00";
		ST_STATE				<= ST_IDLE;
	elsif rising_edge(CLK) then
		if DIV_CLK = '1' then
			case (ST_STATE)is
				when ST_IDLE	=>
					if START_I = '1' then
						I_DTR0_N				<='1';
						I_TXD0				<='0'; 	
						I_RTS0_N				<='1';					
						ST_STATE		<= ST_TEST1 after 2 ns;
					end if;
				when ST_TEST1	=>											--RS232 INACTIVE
					if (I_RXD0='1')or(I_CTS0_N='0')or(I_DSR0_N='0')or(I_DCD0_N='0')or(I_RI0_N='0')then
						I_ERR_COD <= X"01";
						ST_STATE		<= ST_ERROR after 2 ns;
					else
						I_DTR0_N				<='0';
						I_TXD0				<='1'; 	
						I_RTS0_N				<='0';
						ST_STATE		<= ST_TEST2 after 2 ns;
					end if;
				when ST_TEST2	=>											--RS232 ACTIVE
					if (I_RXD0='0')or(I_CTS0_N='1')or(I_DSR0_N='1')or(I_DCD0_N='1')or(I_RI0_N='1')then
						I_ERR_COD <= X"02";
						ST_STATE		<= ST_ERROR after 2 ns;
					else 
						I_RXD1_ENA_N 	<='1';
						I_TXD1_ENA	 	<='1';
						I_TXD1			<='0';
						I_RXD2_ENA_N	<='0';
						I_TXD2_ENA		<='0';
						I_TXD2			<='0';
						ST_STATE		<= ST_TEST3 after 2 ns;
					end if;
				when ST_TEST3	=>											--RS485 INACTIVE TX1_ENA ,RX2 ENA
					if RXD2 = '1' then
						I_ERR_COD <= X"03";
						ST_STATE		<= ST_ERROR after 2 ns;
					else 
						I_TXD1			<='1';
						ST_STATE		<= ST_TEST4 after 2 ns;
					end if;
				when ST_TEST4	=>											--RS485 ACTIVE TX1_ENA ,RX2 ENA
					if RXD2 = '0' then
						I_ERR_COD <= X"04";
						ST_STATE		<= ST_ERROR after 2 ns;
					else 
						I_RXD1_ENA_N 	<='0';
						I_TXD1_ENA	 	<='0';
						I_TXD1			<='0';
						I_RXD2_ENA_N	<='1';
						I_TXD2_ENA		<='1';
						I_TXD2			<='0';
						ST_STATE		<= ST_TEST5 after 2 ns;
					end if;
				when ST_TEST5	=>											--RS485 INACTIVE TX2_ENA ,RX1 ENA
					if RXD1 = '1' then
						I_ERR_COD <= X"05";
						ST_STATE		<= ST_ERROR after 2 ns;
					else 
						I_TXD2			<='1';
						ST_STATE		<= ST_TEST6 after 2 ns;
					end if;
				when ST_TEST6	=>											--RS485 ACTIVE TX2_ENA ,RX1 ENA
					if RXD1 = '0' then
						I_ERR_COD <= X"06";
						ST_STATE		<= ST_ERROR after 2 ns;
					else 
						I_ERR_COD <= X"FF";
						ST_STATE		<= ST_END1 after 2 ns;
					end if;
				when ST_END1	=>	
						ST_STATE		<= ST_INIT_D1 after 2 ns;
				when ST_INIT_D1	=>										--RS232 PATTERN TEST
					TX_REG		<= TX_PAT after 2 ns;	
					BIT_CNT		<= CONV_STD_LOGIC_VECTOR(33,6)after 2 ns;	
					ST_STATE		<= ST_TXRX_D1 after 2 ns;
				when ST_TXRX_D1	=>
					if BIT_CNT = 0 then
						ST_STATE		<= ST_TEST_D1 after 2 ns;
					else
						TX_REG		<= TX_REG (30 downto 0)&  not I_RXD0 after 2 ns;
						I_TXD0		<= TX_REG(31)after 2 ns;
						BIT_CNT		<= BIT_CNT -1 after 2 ns;
					end if;
				when ST_TEST_D1	=>
					if TX_REG /= not TX_PAT  then
						I_ERR_COD <= X"10";
						ST_STATE		<= ST_ERROR after 2 ns;
					else
						I_ERR_COD <= X"FF";
						ST_STATE		<= ST_END2 after 2 ns;
					end if;
				when ST_END2	=>
						ST_STATE		<= ST_INIT_D2 after 2 ns;
				when ST_INIT_D2	=>										--RS485 1 -> 2 PATTERN TEST
					TX_REG		<= TX_PAT after 2 ns;	
					BIT_CNT		<= CONV_STD_LOGIC_VECTOR(33,6)after 2 ns;	
					ST_STATE		<= ST_TXRX_D2 after 2 ns;
				when ST_TXRX_D2	=>
					if BIT_CNT = 0 then
						ST_STATE		<= ST_TEST_D2 after 2 ns;
					else
						TX_REG			<= TX_REG (30 downto 0)&  not I_RXD2 after 2 ns;
						BIT_CNT			<= BIT_CNT -1 after 2 ns;
						I_RXD1_ENA_N	<= '1';
						I_TXD1_ENA		<= '1';
						I_RXD2_ENA_N	<= '0';
						I_TXD2_ENA		<= '0';
						I_TXD1 			<= TX_REG(31)after 2 ns;						
					end if;
				when ST_TEST_D2	=>
					if TX_REG /= not TX_PAT  then
						I_ERR_COD <= X"20";
						ST_STATE		<= ST_ERROR after 2 ns;
					else
						I_ERR_COD <= X"FF";
						ST_STATE		<= ST_END3 after 2 ns;
					end if;
				when ST_END3	=>
						ST_STATE		<= ST_INIT_D3 after 2 ns;
						
				when ST_INIT_D3	=>										--RS485 2 -> 1 PATTERN TEST
					TX_REG		<= TX_PAT after 2 ns;	
					BIT_CNT		<= CONV_STD_LOGIC_VECTOR(33,6)after 2 ns;	
					ST_STATE		<= ST_TXRX_D3 after 2 ns;
				when ST_TXRX_D3	=>
					if BIT_CNT = 0 then
						ST_STATE		<= ST_TEST_D3 after 2 ns;
					else
						TX_REG			<= TX_REG (30 downto 0)&  not I_RXD1 after 2 ns;
						BIT_CNT			<= BIT_CNT -1 after 2 ns;
						I_RXD1_ENA_N	<= '0';
						I_TXD1_ENA		<= '0';
						I_RXD2_ENA_N	<= '1';
						I_TXD2_ENA		<= '1';
						I_TXD2 			<= TX_REG(31)after 2 ns;						
					end if;
				when ST_TEST_D3	=>
					if TX_REG /= not TX_PAT  then
						I_ERR_COD <= X"30";
						ST_STATE		<= ST_ERROR after 2 ns;
					else
						I_ERR_COD <= X"FF";
						ST_STATE		<= ST_END4 after 2 ns;
					end if;
				when ST_END4	=>
					if SWITCH_1_N = '0' then
						ST_STATE		<= ST_IDLE after 2 ns;
					else
						ST_STATE		<= ST_END4 after 2 ns;
					end if;
				when ST_ERROR	=>	
					ST_STATE		<= ST_ERROR after 2 ns;
			end case;
		end if;
	end if;
end process; 



LED1_N <='0' when I_ERR_COD = X"FF" 															else
		   '0' when I_ERR_COD > X"02"																else
			'0' when I_ERR_COD >= X"01" and I_ERR_COD < X"03" and BLINK = '1'			else
			'1';
					
LED2_N <='0' when I_ERR_COD = X"FF" 															else
		   '0' when I_ERR_COD > X"06"																else
			'0' when I_ERR_COD >= X"03" and I_ERR_COD < X"07" and BLINK = '1'			else
			'1';
			
LED3_N <='0' when I_ERR_COD = X"FF" 															else
			'0' when I_ERR_COD > X"11"																else
			'0' when I_ERR_COD >= X"10" and I_ERR_COD < X"12" and BLINK = '1'			else
			'1';

LED4_N <='0' when I_ERR_COD = X"FF" 															else
			'0' when I_ERR_COD > X"21"																else
			'0' when I_ERR_COD >= X"20" and I_ERR_COD < X"22" and BLINK = '1'			else
			'1';
			



end Behavioral;

